package fr.gaellalire.maven_jar_exploder;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;

import fr.gaellalire.maven_jar_exploder.DynamicZip.FileMeta;
import fr.gaellalire.maven_jar_exploder.DynamicZip.ZipMeta;

public class GeneratedZipFileMeta extends AbstractZipArchiveEntryFileMeta implements FileMeta {
    
    private List<FileMeta> fileMetas;
    
    private boolean zip64;
    
    public GeneratedZipFileMeta(ZipArchiveEntry zipArchiveEntry, String sha512, List<FileMeta> fileMetas) throws IOException {
        super(zipArchiveEntry, sha512, null);
        this.fileMetas = fileMetas;
        long size64 = DynamicZip.calculateZipMeta(fileMetas, true).getSize();
        if (zipArchiveEntry.getSize() == size64) {
            zip64 = true;
        } else {
            ZipMeta zip32Meta = DynamicZip.calculateZipMeta(fileMetas, false);
            if (zip32Meta == null) {
                throw new IOException("Unable to match size expected:\n" + zipArchiveEntry.getSize() + " \n64bits:\n" + size64);
            }
            if (zipArchiveEntry.getSize() != zip32Meta.getSize()) {
                throw new IOException("Unable to match size expected:\n" + zipArchiveEntry.getSize() + "\n32bits:\n" + zip32Meta.getSize() + " \n64bits:\n" + size64);
            }            
        }
    }

    @Override
    public InputStream getInputStream(long from, long size) throws IOException {
        return DynamicZip.getInputStream(fileMetas, from, size, zip64);
    }

}
